include<metric.scad>;
include<util.scad>;
include<tile.scad>;

module pack_shape() {
    k = 0.1;

    square([ 38 + 2 * k, 81 + 2 * k ], center = true);

    for (i = [ -1, 1 ])
        translate([ 0, i * (21 + 20) / 2, 0 ])
            square([ 43 + 2 * k, 20 + 2 * k ], center = true);

    for (i = [ -1, 1 ])
        translate([ i * (6 + 10) / 2, 0, 0 ])
            square([ 10 + 2 * k, 186 + 2 * k ], center = true);
}

power_dist_y = 78;
power_dist_x = [ -11, -6, 6, 11 ];

module bat_set() difference() {
    h = 5;

    for (i = [-0.5:0.5], j = [-1.5:1.5])
        translate([ i * Ta(T24), j * Ta(T24), 0 ]) tile_pos(T24, h);

    linear_extrude(height = 3.5 * 2, center = true) pack_shape();

    for (i = [-0.5:0.5], j = [-1.5:1.5])
        translate([ i * Ta(T24), j * Ta(T24), 0 ]) tile_neg(T24, h);

    for (i = [ -0.5, 0.5 ], x = power_dist_x)
        translate([ x, i * power_dist_y, 0 ])
            cylinder(d = 3, h = 100, center = true);
}

bat_set();
